-- Function for instances
function ins(m)
	local int = {}
	for i = 1, m do
		int[i]=0
	end
	return int
end

-- instances
grapling=ins(32)
grapimage=ins(32)
grapx=ins(32)
grapy=ins(32)
grapcheck=ins(32)
graprot=ins(32)
xbefore=ins(32)
ybefore=ins(32)

graprange = 200
grapspeed = 10 -- recommended

--hooks
addhook("key","s_client")
addhook("always","s_always")
addhook("startround","s_start")


--binds
addbind("mouse2")


--function
function graps(p,xe,ye)
imagealpha(grapimage[p],0)
grapcheck[p]=0
local rot = -math.deg(math.atan2(player(p,"x")-xe,player(p,"y")-ye))
if rot < -90 then rot = rot + 360 end
local angle = math.rad(math.abs( rot + 90 )) - math.pi
for cw = 1,(graprange*2) do
local xs = player(p,[[x]]) + math.cos(angle) * cw
local ys = player(p,[[y]]) + math.sin(angle) * cw
if xs > 0 and ys > 0 and xs < map([[xsize]]) * 32 and ys < map([[ysize]]) * 32 then
if tile(math.floor(xs/32),math.floor(ys/32),"wall") then
if grapcheck[p]<=0 then
grapcheck[p]=1
grapx[p]=xs
grapy[p]=ys
grapling[p]=1
grapimage[p]=image("gfx/grapline.bmp",0,0,1)
timer(10000,"freeimage",grapimage[p])
graprot[p]=rot
end
end
end
end
end

function s_start()
for d = 1,32 do
grapimage[d]=image("gfx/grapline.bmp",0,0,1)
end
end

function s_always()
for p = 1,32 do
if player(p,"exists") then
if grapling[p]>0 then
if tile(player(p,"tilex"),player(p,"tiley"),"walkable") then
xbefore[p]=player(p,"x")
ybefore[p]=player(p,"y")
end
local rot = -math.deg(math.atan2(player(p,"x") - grapx[p],player(p,"y") - grapy[p]))
if rot < -90 then rot = rot + 360 end
local angle = math.rad(math.abs( rot + 90 )) - math.pi
local x = player(p,[[x]]) + math.cos(angle) * grapspeed
local y = player(p,[[y]]) + math.sin(angle) * grapspeed
if x > 0 and y > 0 and x < map([[xsize]]) * 32 and y < map([[ysize]]) * 32 then
if not tile(math.floor(x/32),math.floor(y/32),"wall") then
going = -math.sqrt((player(p,"x") - grapx[p])^2 + (player(p,"y") - grapy[p])^2)
				imagepos(grapimage[p], grapx[p] + math.sin(math.rad(rot)) * going/2, grapy[p] + -math.cos(math.rad(rot)) * going/2, -math.deg(math.atan2(player(p,"x")-grapx[p],player(p,"y")-grapy[p])))
				imagescale(grapimage[p], 1, going)
parse('setpos '..p..' '..x..' '..y)
end
if player(p,"x")<=grapx[p]+grapspeed and player(p,"x")>=grapx[p]-grapspeed and player(p,"y")<=grapy[p]+grapspeed and player(p,"y")>=grapy[p]-grapspeed then
grapling[p]=0
imagealpha(grapimage[p],0)
if not tile(player(p,"tilex"),player(p,"tiley"),"walkable") then
parse('setpos '..p..' '..xbefore[p]..' '..ybefore[p])
end
end
end
end
end
end
end

function s_client(p,k,s)
if k == "mouse2" and s == 1 and player(p,"weapon")==50 then
graps(p,player(p,"mousemapx"),player(p,"mousemapy"))
end
end






